#' @title Bradley-Terry model environment
#'
#' @include Feedback.R
#' @include evd
#'
#' @description
#' This class specializes a [Feedback] environment with an underlying Bradley-Terry model
#'

BTM = R6Class("BTM", inherit = Feedback,
                         public = list(
                           #' @description
                           #' Creates a new instance of this [R6][R6::R6Class] class.
                           initialize = function(weights, time_horizon, context_matrices = NULL) {
                             super$initialize(weights = weights, time_horizon = time_horizon, context_matrices = context_matrices,  pert_dis = rgumbel)
                           }
                         )
)